uniform sampler2D ColorMapSampler;

void main() 
{
	vec4 sum = vec4(0);
	vec2 texcoord = vec2(gl_TexCoord[0].st);
	int j;
	int i;

	for( i= -4 ;i < 4; i++)
	{
		for (j = -3; j < 3; j++)
		{
			sum += texture2D(ColorMapSampler, texcoord + vec2(j, i)*0.005) * 0.3;
		}
	}
    
	if (texture2D(ColorMapSampler, texcoord).r < 0.3)
	{
		gl_FragColor = sum*sum*0.012 + texture2D(ColorMapSampler, texcoord);
	}
	else
	{
		if (texture2D(ColorMapSampler, texcoord).r < 0.5)
		{
			gl_FragColor = sum*sum*0.009 + texture2D(ColorMapSampler, texcoord);
		}
		else
		{
			gl_FragColor = sum*sum*0.0075 + texture2D(ColorMapSampler, texcoord);
		}
	}
}